local i
local j
local k
local l
local m
local x
local y
local match
local QSL_String
local QSL_Loc
local QSL_QuestName
local QSL_NPCName
local QSL_SubZoneText
local QSL_RealZoneText

QSL_Table = { }

function QuestStartLocation_OnLoad()

	this:RegisterEvent("CHAT_MSG_SYSTEM");

	SLASH_QuestStartLocation1 = "/QuestStartLocation";
	SLASH_QuestStartLocation2 = "/qsl";
	SlashCmdList["QuestStartLocation"] = QuestStartLocation_SlashCommand;
	
	if ( DEFAULT_CHAT_FRAME ) then
	DEFAULT_CHAT_FRAME:AddMessage("QuestStartLocation loaded.",1, 0, 0);
	end
	
end


function QuestStartLocation_OnEvent()
	if (event == "CHAT_MSG_SYSTEM") then
		if (string.find(arg1, "Quest accepted:")) then
		QSL_LogCleanup()
		j, k = string.find(arg1, "Quest accepted:")
		QSL_QuestName = string.sub(arg1, k + 2, -1)
		QSL_QuestName = string.lower(QSL_QuestName)
		QSL_NPCName = UnitName("target")
			if (QSL_NPCName == nil) then
			QSL_NPCName = "Unknown"
			end
		SetMapToCurrentZone()
		QSL_RealZoneText = GetRealZoneText()
			if (QSL_RealZoneText == nil) then
			QSL_RealZoneText = "Unknown"
			end
		QSL_SubZoneText = GetSubZoneText()
			if (QSL_SubZoneText == nil) then
			QSL_SubZoneText = "Unknown"
			end
		x, y = GetPlayerMapPosition("player")
			if ( x == nil or y == nil) then
			QSL_Loc = "Unknown"
			else
			QSL_Loc =  format("(%d:%d) ",x*100.0,y*100.0)
			end
		QSL_Table[QSL_QuestName] = QSL_NPCName ..",".. QSL_RealZoneText ..",".. QSL_SubZoneText ..",".. QSL_Loc
		
		end
	end
end

function QuestStartLocation_SlashCommand(msg)
	if (msg == "help") then
	DEFAULT_CHAT_FRAME:AddMessage("Type /qsl [questname] to get information. Not case sensitive.")
	DEFAULT_CHAT_FRAME:AddMessage("Don't forget to put the brackets around the quest name.")
	end
	if (msg == "clean") then
	QSL_LogCleanup()
	end
	if (msg == "bell") then
	PlaySoundFile("Sound\\Doodad\\BellTollHorde.wav");
	end
	if (string.find(msg, "%[") and string.find(msg, "%]")) then
	j, k = string.find(msg, "%]")
	QSL_QuestName = string.sub(msg, 2, k-1)
	QSL_QuestName = string.lower(QSL_QuestName)
		if (QSL_Table[QSL_QuestName] ~= nil) then
		k = string.upper(QSL_QuestName)
		DEFAULT_CHAT_FRAME:AddMessage("****  " .. k .. " ****")
		QSL_String = QSL_Table[QSL_QuestName]
		j, k = string.find(QSL_String, ",")
		QSL_NPCName = string.sub(QSL_String, 1, k - 1)
		DEFAULT_CHAT_FRAME:AddMessage("The quest giver was - " .. QSL_NPCName)
		l, m = string.find(QSL_String, ",", k + 1)
		QSL_RealZoneText = string.sub(QSL_String, k + 1, m - 1)
		DEFAULT_CHAT_FRAME:AddMessage("In zone - " .. QSL_RealZoneText)
		j, k = string.find(QSL_String, ",", m + 1)
		QSL_SubZoneText = string.sub(QSL_String, m + 1, k - 1)
		DEFAULT_CHAT_FRAME:AddMessage("In subzone - " .. QSL_SubZoneText)
		QSL_Loc = string.sub(QSL_String, k + 1, - 1)
		DEFAULT_CHAT_FRAME:AddMessage("at location - " .. QSL_Loc)
		else
		DEFAULT_CHAT_FRAME:AddMessage("[" .. QSL_QuestName .. "]" .. " quest not found.")
		end
	end
end

function QSL_LogCleanup()
	for QSL_QuestName, l in pairs(QSL_Table) do
	match = "no"
		i=0;
		while (GetQuestLogTitle(i+1) ~= nil) do
	 	i = i + 1;
		local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete = GetQuestLogTitle(i);
			if (not header) then
				if (QSL_QuestName == string.lower(questTitle)) then
				match = "yes"
				end
			end
		end
		if (match == "no") then
		QSL_Table[QSL_QuestName] = nil
		end
	end
end

